## snapd 2.72

=== debian/changelog ===
snapd (2.72-1) unstable; urgency=medium

  [ Ernest Lotter ]
  * New upstream release, LP: #2124239
    - FDE: support replacing TPM protected keys at runtime via the
      /v2/system-volumes endpoint
    - FDE: support secboot preinstall check fix actions for 25.10+
      hybrid installs via the /v2/system/{label} endpoint
    - FDE: tweak polkit message to remove jargon
    - FDE: ensure proper sealing with kernel command line defaults
    - FDE: provide generic reseal function
    - FDE: support using OPTEE for protecting keys, as an alternative to
      existing fde-setup hooks (Ubuntu Core only)
    - Confdb: 'snapctl get --view' supports passing default values
    - Confdb: content sub-rules in confdb-schemas inherit their parent
      rule's "access"
    - Confdb: make confdb error kinds used in API more generic
    - Confdb: fully support lists and indexed paths (including unset)
    - Prompting: add notice backend for prompting types (unused for now)
    - Prompting: include request cgroup in prompt
    - Prompting: handle unsupported xattrs
    - Prompting: add permission mapping for the camera interface
    - Notices: read notices from state without state lock
    - Notices: add methods to get notice fields and create, reoccur, and
      deepcopy notice
    - Notices: add notice manager to coordinate separate notice backends
    - Notices: support draining notices from state when notice backend
      registered as producer of a particular notice type
    - Notices: query notice manager from daemon instead of querying
      state for notices directly
    - Packaging: Ubuntu | ignore .git directory
    - Packaging: FIPS | bump deb Go FIPS to 1.23
    - Packaging: snap | bump FIPS toolchain to 1.23
    - Packaging: debian | sync most upstream changes
    - Packaging: debian-sid | depends on libcap2-bin for postint
    - Packaging: Fedora | drop fakeroot
    - Packaging: snap | modify snapd.mk to pass build tags when running
      unit tests
    - Packaging: snap | modify snapd.mk to pass nooptee build tag
    - Packaging: modify Makefile.am to fix snap-confine install profile
      with 'make hack'
    - Packaging: modify Makefile.am to fix out-of-tree use of 'make
      hack'
    - LP: #2122054 Snap installation: skip snap icon download when
      running in a cloud or using a proxy store
    - Snap installation: add timeout to http client when downloading
      snap icon
    - Snap installation: use http(s) proxy for icon downloads
    - LP: #2117558 snap-confine: fix error message with /root/snap not
      accessible
    - snap-confine: fix non-suid limitation by switching to root:root to
      operate v1 freezer
    - core-initrd: do not use writable-paths when not available
    - core-initrd: remove debian folder
    - LP: #1916244 Interfaces: gpio-chardev | re-enable the gpio-chardev
      interface now with the more robust gpio-aggregator configfs kernel
      interface
    - Interfaces: gpio-chardev | exclusive snap connections, raise a
      conflict when both gpio-chardev and gpio are connected
    - Interfaces: gpio-chardev | fix gpio-aggregator module load order
    - Interfaces: ros-snapd-support | grant access to /v2/changes
    - Interfaces: uda-driver-libs, egl-driver-libs, gbm-driver-libs,
      opengl-driver-libs, opengles-driver-libs | new interfaces to
      support nvidia driver components
    - Interfaces: microstack-support | allow DPDK (hugepage related
      permissions)
    - Interfaces: system-observe | allow reading additional files in
      /proc, needed by node-exporter
    - Interfaces: u2f | add Cano Key, Thesis FIDO2 BioFP+ Security Key
      and Kensington VeriMark DT Fingerprint Key to device list
    - Interfaces: snap-interfaces-requests-control | allow shell API
      control
    - Interfaces: fwupd | allow access to Intel CVS sysfs
    - Interfaces: hardware-observe | allow read access to Kernel
      Samepage Merging (KSM)
    - Interfaces: xilinx-dma | support Multi Queue DMA (QDMA) IP
    - Interfaces: spi | relax sysfs permission rules to allow access to
      SPI device node attributes
    - Interfaces: content | introduce compatibility label
    - LP: #2121238 Interfaces: do not expose Kerberos tickets for
      classic snaps
    - Interfaces: ssh-public-keys | allow ro access to public host keys
      with ssh-key
    - Interfaces: Modify AppArmor template to allow listing systemd
      credentials and invoking systemd-creds
    - Interfaces: modify AppArmor template with workarounds for Go 1.35
      cgroup aware GOMAXPROCS
    - Interfaces: modify seccomp template to allow landlock_*
    - Prevent snap hooks from running while relevant snaps are unlinked
    - Make refreshes wait before unlinking snaps if running hooks can be
      affected
    - Fix systemd unit generation by moving "WantedBy=" from section
      "unit" to "install"
    - Add opt-in logging support for snap-update-ns
    - Unhide 'snap help' sign and export-key under Development category
    - LP: #2117121 Cleanly support socket activation for classic snap
    - Add architecture to 'snap version' output
    - Add 'snap debug api' option to disable authentication through
      auth.json
    - Show grade in notes for 'snap info --verbose'
    - Fix preseeding failure due to scan-disk issue on RPi
    - Support 'snap debug api' queries to user session agents
    - LP: #2112626 Improve progress reporting for snap install/refresh
    - Drop legacy BAMF_DESKTOP_FILE_HINT in desktop files
    - Fix /v2/apps error for root user when user services are present
    - LP: #2114704 Extend output to indicate when snap data snapshot was
      created during remove
    - Improve how we handle emmc volumes
    - Improve handling of system-user extra assertions

 -- Zygmunt Krynicki <me@zygoon.pl>  Fri, 21 Nov 2025 11:54:27 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# These rules should work for any debian-ish distro that uses systemd
# as init.  That does _not_ include Ubuntu 14.04 ("trusty"); look for
# its own special rule file.
#
# Please keep the diff between that and this relatively small, even if
# it means having suboptimal code; these need to be kept in sync by
# sentient bags of meat.

#export DH_VERBOSE=1
export DH_OPTIONS
export DH_GOPKG := github.com/snapcore/snapd
#export DEB_BUILD_OPTIONS=nocheck
export DH_GOLANG_EXCLUDES=tests
export DH_GOLANG_BUILDPKG = $(strip $(addprefix $(DH_GOPKG)/, \
    cmd/snap \
    cmd/snap-exec \
    cmd/snap-seccomp \
    cmd/snap-update-ns \
    cmd/snapctl \
    cmd/snapd \
    cmd/snapd-apparmor \
    ))
# skip Go generate, all source code should have been committed
export DH_GOLANG_GO_GENERATE=0

export PATH:=${PATH}:${CURDIR}
# GOCACHE is needed by go-1.13+
export GOCACHE:=/tmp/go-build

include /etc/os-release

# On 18.04 the released version of apt (1.6.1) has a bug that causes
# problem on "apt purge snapd". To ensure this won't happen add the
# right dependency on 18.04.
ifeq (${VERSION_ID},"18.04")
	SUBSTVARS = -Vsnapd:Breaks="apt (<< 1.6.3)"
endif
# Same as above for 18.10 just a different version.
ifeq (${VERSION_ID},"18.10")
	SUBSTVARS = -Vsnapd:Breaks="apt (<< 1.7.0~alpha2)"
endif

# this is overridden in the ubuntu/14.04 release branch
SYSTEMD_UNITS_DESTDIR="$(shell pkg-config --variable=systemdsystemunitdir systemd)"

# The go tool does not fully support vendoring with gccgo, but we can
# work around that by constructing the appropriate -I flag by hand.
GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)

# Disable -buildmode=pie mode on i386 as can panics in spectacular
# ways (LP: #1711052).
# See also https://forum.snapcraft.io/t/artful-i386-panics/
# Note while the panic is only on artful, that's because artful
# detects it; the issue potentially there on older things.
BUILDFLAGS:=-pkgdir=$(CURDIR)/_build/std
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
BUILDFLAGS+= -buildmode=pie
endif

GCCGOFLAGS=
ifeq ($(GCCGO),yes)
GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)
BUILDFLAGS:=
GCCGOFLAGS=-gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
export DH_GOLANG_GO_GENERATE=0
# workaround for https://github.com/golang/go/issues/23721
export GOMAXPROCS=2
endif

# check if we need to include the testkeys in the binary
# TAGS are the go build tags for all binaries, SNAP_TAGS are for snap
# build only.
TAGS=nosecboot
SNAP_TAGS=nosecboot nomanagers
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
	TAGS+= withtestkeys
	SNAP_TAGS+= withtestkeys
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# /usr/lib/snapd/snap-{update-ns,gdbserver-shim,gdb-shim} are always linked
# statically against glibc. Use libc-dev-bin to avoid having to handle the
# different soname (e.g. libc6 vs libc6.1)
BUILT_USING_PACKAGES=libc-dev-bin

# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Currently, we enable confinement for Ubuntu only, not for derivatives,
# because derivatives may have different kernels that don't support all the
# required confinement features and we don't to mislead anyone about the
# security of the system.  Discuss a proper approach to this for downstreams
# if and when they approach us.
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
    # On Ubuntu 16.04 we need to produce a build that can be used on wide
    # variety of systems. As such we prefer static linking over dynamic linking
    # for stability, predicability and easy of deployment. We need to link some
    # things dynamically though: udev has no stable IPC protocol between
    # libudev and udevd so we need to link with it dynamically.
    VENDOR_ARGS=--enable-nvidia-multiarch --enable-static-libcap --enable-static-libapparmor --enable-static-libseccomp --with-host-arch-triplet=$(DEB_HOST_MULTIARCH)
ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),amd64)
		VENDOR_ARGS+= --with-host-arch-32bit-triplet=$(shell dpkg-architecture -f -ai386 -qDEB_HOST_MULTIARCH)
endif
    BUILT_USING_PACKAGES+=libcap-dev libapparmor-dev libseccomp-dev
else
ifeq ($(shell dpkg-vendor --query Vendor),Debian)
    VENDOR_ARGS=--enable-nvidia-multiarch
    BUILT_USING_PACKAGES+=libcap-dev
else
    VENDOR_ARGS=--disable-apparmor
endif
endif
BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_fixperms:
	dh_fixperms -Xusr/lib/snapd/snap-confine


# The .real profile is a workaround for a bug in dpkg LP: #1673247 that causes
# ubiquity to crash. It allows us to "move" the snap-confine profile from
# snap-confine into snapd in a way that works with old dpkg that is in the live
# CD image.
#
# Because both the usual and the .real profile describe the same binary the
# .real profile takes priority (as it is loaded later).
override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.snapd.snap-confine.real -psnapd
	dh_installdeb

override_dh_clean:
	dh_clean
	$(MAKE) -C data clean
	# XXX: hacky
	$(MAKE) -C cmd distclean || true

override_dh_auto_build:
	# usually done via `go generate` but that is not supported on powerpc
	GO_GENERATE_BUILDDIR=_build/src/$(DH_GOPKG) GO111MODULE=off GOPATH=$$(pwd)/_build ./mkversion.sh
	# Build golang bits
	mkdir -p _build/src/$(DH_GOPKG)/cmd/snap/test-data
	cp -a cmd/snap/test-data/*.gpg _build/src/$(DH_GOPKG)/cmd/snap/test-data/
	cp -a bootloader/assets/data _build/src/$(DH_GOPKG)/bootloader/assets

	# exclude certain parts that won't be used by debian
	find _build/src/$(DH_GOPKG)/cmd/snap-bootstrap -name "*.go" | xargs rm -f
	find _build/src/$(DH_GOPKG)/cmd/snap-fde-keymgr -name "*.go" | xargs rm -f
	find _build/src/$(DH_GOPKG)/gadget/install -name "*.go" | grep -vE '(params\.go|install_dummy\.go|kernel\.go)'| xargs rm -f
	# XXX: once dh-golang understands go build tags this would not be needed
	find _build/src/$(DH_GOPKG)/secboot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go|.*_tpm(_test)?\.go|secboot_hooks.go|auth_requestor.go|keymgr/)' | xargs rm -f
	mv _build/src/$(DH_GOPKG)/secboot/keys/plainkey.go _build/src/$(DH_GOPKG)/secboot/keys/plainkey_sb.go
	mv _build/src/$(DH_GOPKG)/secboot/keys/plainkey_test.go _build/src/$(DH_GOPKG)/secboot/keys/plainkey_sb_test.go
	find _build/src/$(DH_GOPKG)/secboot/keys/ -name "*.go" | grep -E '(.*_sb(_test)?\.go)' | xargs rm -f
	find _build/src/$(DH_GOPKG)/boot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go)' | xargs rm -f
	# and build, we cannot use modules as packaging on Debian requires us to use
	# dependencies from the distro, and this would require further updates to the
	# go.mod file
	GO111MODULE=off dh_auto_build -- $(BUILDFLAGS) -tags "$(TAGS)" $(GCCGOFLAGS)

	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. go build $(BUILDFLAGS) $(GCCGOFLAGS) -tags "$(SNAP_TAGS)" $(DH_GOPKG)/cmd/snap)

	# (static linking on powerpc with cgo is broken)
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),powerpc)
	# Generate static snap-exec, snapctl and snap-update-ns - it somehow includes CGO so
	# we must force a static build here. We need a static snap-{exec,update-ns}
	# inside the core snap because not all bases will have a libc
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. CGO_ENABLED=0 go build -tags "$(TAGS)" $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-exec)
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. CGO_ENABLED=0 go build -tags "$(TAGS)" $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snapctl)
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. go build -tags "$(TAGS)" --ldflags '-extldflags "-static"' $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-update-ns)

	# ensure we generated a static build

=== debian/watch ===
version=4
  opts="searchmode=plain, \
  filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
  https://api.github.com/repos/snapcore/snapd/releases?per_page=100 \
  https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@

## snapd 2.72%2Bubuntu24.04

=== tests/lib/snaps/store/test-snapd-uhid/Makefile ===
CFLAGS += -Wall -Werror
.PHONY: all
all: uhid-test

uhid-test: uhid-test.c

## snapd 2.72+ubuntu22.04

=== tests/utils/features/requirements.txt ===
dash
dash-bootstrap-components
dash-daq
pymongo

=== tests/lib/snaps/store/test-snapd-hello-classic/Makefile ===
test-snapd-hello-classic.bin: test-snapd-hello-classic.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<

install: test-snapd-hello-classic.bin
	install -D -t $(DESTDIR)/bin -m 0755 test-snapd-hello-classic.bin

.PHONY: clean
clean:
	rm -f test-snapd-hello-classic.bin

=== tests/lib/snaps/store/test-snapd-setpriority/Makefile ===
CFLAGS += -Wall -Werror
.PHONY: all
all: setpriority

setpriority: setpriority.c

=== core-initrd/24.04/debian/changelog ===
ubuntu-core-initramfs (69+2.71+g129.cddf2e3+24.04) noble; urgency=medium

  * Update to snapd version 2.71+g129.cddf2e3

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 28 Aug 2025 15:56:35 -0400

## snapd 2.72+ubuntu24.04

=== data/dbus/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BINDIR := /usr/bin
DBUSDIR = /usr/share/dbus-1
DBUSSERVICESDIR := ${DBUSDIR}/services

SERVICES_GENERATED := $(patsubst %.service.in,%.service,$(wildcard *.service.in))
SERVICES := ${SERVICES_GENERATED}

%.service: %.service.in
	cat $< | sed 's:@bindir@:${BINDIR}:g' | cat > $@

all: ${SERVICES}

install:: ${SERVICES}
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 ${DESTDIR}/${DBUSSERVICESDIR}
	install -m 0644 -t ${DESTDIR}/${DBUSSERVICESDIR} $^

install:: snapd.session-services.conf
	install -d -m 0755 ${DESTDIR}/${DBUSDIR}/session.d
	install -m 0644 -t ${DESTDIR}/${DBUSDIR}/session.d $^

install:: snapd.system-services.conf
	install -d -m 0755 ${DESTDIR}/${DBUSDIR}/system.d
	install -m 0644 -t ${DESTDIR}/${DBUSDIR}/system.d $^

clean:
	rm -f ${SERVICES_GENERATED}

=== data/selinux/Makefile ===
# This file is part of snapd-selinux
# Copyright (C) 2016 Neal Gompa
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.


TARGETS?= snappy
SHARE?=/usr/share
MODULES?=${TARGETS:=.pp.bz2}

all: ${TARGETS:=.pp.bz2}

%.pp.bz2: %.pp
	@echo Compressing $^ -\ $@
	bzip2 -9 $^

%.pp: %.te
	make -f ${SHARE}/selinux/devel/Makefile $@

clean:
	rm -f *~ *.tc *.pp *.pp.bz2
	rm -rf tmp

=== core-initrd/25.04/debian/changelog ===
ubuntu-core-initramfs (71+2.71+g129.cddf2e3+25.04) plucky; urgency=medium

  * Update to snapd version 2.71+g129.cddf2e3

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 28 Aug 2025 15:57:01 -0400

=== core-initrd/24.04/debian/control ===
Source: ubuntu-core-initramfs
Section: utils
Priority: optional
Maintainer: Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>
Build-Depends: debhelper-compat (= 13), dh-python,
               cpio,
               fakeroot,
               fonts-ubuntu,
               libblkid-dev,
               golang-go (>=2:1.18~) [!powerpc] | golang-1.18 [!powerpc] | golang-1.21,
               pkgconf,
               optee-client-dev [arm64 armhf]
Standards-Version: 4.4.1
Homepage: https://launchpad.net/ubuntu-core-initramfs

Package: ubuntu-core-initramfs
Architecture: amd64 arm64 armhf riscv64
Depends: ${python3:Depends}, ${misc:Depends}, dracut-core (>= 051-1),
         python3:any,
         dracut-core,
         busybox-initramfs,
         zstd,
         sbsigntool,
         linux-firmware,
         kcapi-tools (>= 1.4.0-1ubuntu3),
         dbus,
         dmsetup,
         dosfstools,
         dpkg-dev,
         e2fsprogs,
         fakeroot,
         fdisk,
         git,
         kmod,
         libblkid1,
         libgcc-s1,
         mount,
         plymouth-label-ft,
         plymouth-theme-spinner,
         squashfs-tools,
         systemd,
         systemd-boot-efi,
         systemd-ukify,
         systemd-bootchart,
         cryptsetup-bin,
         systemd-sysv,
         tar,
         udev,
         util-linux,
         amd64-microcode [amd64],
         intel-microcode [amd64],
         libteec1 [arm64 armhf]
Description: standard embedded initrd
 Standard embedded initrd implementation to be used with Ubuntu Core
 systems. Currently targeting creating BLS Type2 like binaries.

=== core-initrd/25.04/debian/control ===
Source: ubuntu-core-initramfs
Section: utils
Priority: optional
Maintainer: Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>
Build-Depends: debhelper-compat (= 13), dh-python,
               cpio,
               fakeroot,
               fonts-ubuntu,
               libblkid-dev,
               golang-go (>=2:1.18~) [!powerpc] | golang-1.18 [!powerpc] | golang-1.21,
               pkgconf,
               optee-client-dev [arm64 armhf]
Standards-Version: 4.4.1
Homepage: https://launchpad.net/ubuntu-core-initramfs

Package: ubuntu-core-initramfs
Architecture: amd64 arm64 armhf riscv64
Depends: ${python3:Depends}, ${misc:Depends}, dracut-core (>= 051-1),
         python3:any,
         dracut-core,
         busybox-initramfs,
         zstd,
         sbsigntool,
         linux-firmware,
         kcapi-tools (>= 1.4.0-1ubuntu3),
         dbus,
         dmsetup,
         dosfstools,
         dpkg-dev,
         e2fsprogs,
         fakeroot,
         fdisk,
         git,
         kmod,
         libblkid1,
         libgcc-s1,
         libkmod2,
         mount,
         plymouth-label-ft,
         plymouth-theme-spinner,
         squashfs-tools,
         systemd,
         systemd-boot-efi,
         systemd-ukify,
         systemd-bootchart,
         systemd-cryptsetup,
         cryptsetup-bin,
         systemd-sysv,
         tar,
         udev,
         util-linux,
         dh-dlopenlibdeps,
         amd64-microcode [amd64],
         intel-microcode [amd64],
         libteec1 [arm64 armhf]
Description: standard embedded initrd
 Standard embedded initrd implementation to be used with Ubuntu Core
 systems. Currently targeting creating BLS Type2 like binaries.

## snapd 2.72+ubuntu25.04

=== data/desktop/Makefile ===
#
# Copyright (C) 2018 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BINDIR = /usr/bin
SYSCONFXDGAUTOSTARTDIR = /etc/xdg/autostart
APPLICATIONSDIR = /usr/share/applications

DESKTOP_SOURCES = snap-handle-link.desktop.in io.snapcraft.SessionAgent.desktop.in
DESKTOP_FILES = $(DESKTOP_SOURCES:.in=)

AUTOSTART_SOURCES = snap-userd-autostart.desktop.in
AUTOSTART_FILES = $(AUTOSTART_SOURCES:.in=)

ICON_FILES = snapcraft-logo-bird.svg
ICON_FOLDER = /usr/share/snapd

.PHONY: all
all: $(DESKTOP_FILES) $(AUTOSTART_FILES)

.PHONY: install
# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
install:: $(DESKTOP_FILES)
	install -d -m 0755 $(DESTDIR)/$(APPLICATIONSDIR)
	install -m 0644 -t $(DESTDIR)/$(APPLICATIONSDIR) $^

install:: $(AUTOSTART_FILES)
	install -d -m 0755 $(DESTDIR)/$(SYSCONFXDGAUTOSTARTDIR)
	install -m 0644 -t $(DESTDIR)/$(SYSCONFXDGAUTOSTARTDIR) $^

install:: $(ICON_FILES)
	install -d -m 0755 $(DESTDIR)/$(ICON_FOLDER)
	install -m 0644 -t $(DESTDIR)/$(ICON_FOLDER) $^

.PHONY: clean
clean:
	rm -f $(DESKTOP_FILES) $(AUTOSTART_FILES)

%: %.in
	cat $< | \
		sed s:@bindir@:$(BINDIR):g | \
		sed s:@icondir@:$(ICON_FOLDER):g | \
		cat > $@

=== tests/lib/snaps/store/test-snapd-fuse-consumer/Makefile ===
# -*- Mode: Makefile; indent-tabs-mode:t; tab-width: 4 -*-

all:

install:
	mkdir -p $(DESTDIR)/bin
	cp -a /usr/share/doc/python-fuse/examples/example/hello.py $(DESTDIR)/bin/create
	cp -a /usr/share/doc/python-fuse/examples/example/_find_fuse_parts.py $(DESTDIR)/bin
	chmod a+x $(DESTDIR)/bin/create

## snapd 2.72+ubuntu25.10.2

=== data/env/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SNAP_MOUNT_DIR := /snap
ENVD := /etc/profile.d
DATADIR ?= /usr/share

%.sh: %.sh.in
	sed   < $< > $@ \
		s:@SNAP_MOUNT_DIR@:${SNAP_MOUNT_DIR}:g

%.fish: %.fish.in
	sed   < $< > $@ \
		s:@SNAP_MOUNT_DIR@:${SNAP_MOUNT_DIR}:g

GENERATED_SH = snapd.sh
GENERATED_FISH = snapd.fish
GENERATED = ${GENERATED_SH} ${GENERATED_FISH}

all: ${GENERATED}
.PHONY: all

install-sh: ${GENERATED_SH}
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 ${DESTDIR}/${ENVD}
	install -m 0644 -t ${DESTDIR}/${ENVD} $^

# fish uses a separate directory to store vendor configuration files
install-fish: ${GENERATED_FISH}
	install -d -m 0755 ${DESTDIR}/${DATADIR}/fish/vendor_conf.d
	install -m 0644 -t ${DESTDIR}/${DATADIR}/fish/vendor_conf.d $^

install: install-sh install-fish
.PHONY: install install-sh install-fish

clean:
	$(RM) ${GENERATED}
.PHONY: clean

=== tests/lib/snaps/store/test-snapd-daemon-user/src/Makefile ===
# could use 'uname_p := $(shell uname -p)' but this doesn't work right on the
# builders where i386 is built in a 32 bit chroot with amd64 kernel (eg, LP)
# amd64		x86_64-linux-gnu
# arm64		aarch64-linux-gnu
# armhf		arm-linux-gnueabihf
# i386		i386-linux-gnu
# ppc64el	powerpc64le-linux-gnu
# s390x		s390x-linux-gnu
arch_triplet := $(SNAPCRAFT_ARCH_TRIPLET)

CFLAGS += -g -O0 -Wall -Wstrict-prototypes

# snapcraft will copy anything from here
INSTALL_DIR := ../../install/bin

buildNative := drop drop-exec drop-syscall setgid setregid setresgid setuid setreuid setresuid chown lchown fchown fchownat
buildSecond := drop32 drop-exec32 drop-syscall32 setgid32 setregid32 setresgid32 setuid32 setreuid32 setresuid32 chown32 lchown32 fchown32 fchownat32

#ifneq (,$(filter $(arch_triplet), x86_64-linux-gnu aarch64-linux-gnu))
ifneq (,$(filter $(arch_triplet), x86_64-linux-gnu))
all: $(buildNative) $(buildSecond)
else
all: $(buildNative)
endif

display.o: display.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop.o: drop.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop: display.o drop.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

drop-exec.o: drop-exec.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop-exec: display.o drop-exec.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

# Since drop-syscall bypasses glibc, 32 bit archs need to use drop-syscall32.c
# with the *32 syscalls for set*id/setgroups to uids/gids > 2^16. For all the
# other binaries, glibc is used and does this automatically.
ifneq (,$(filter $(arch_triplet), i386-linux-gnu arm-linux-gnueabihf))
drop-syscall.o: drop-syscall32.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop-syscall: display.o drop-syscall32.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}
else
drop-syscall.o: drop-syscall.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop-syscall: display.o drop-syscall.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}
endif

setgid.o: setgid.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setgid: display.o setgid.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setregid.o: setregid.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setregid: display.o setregid.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setresgid.o: setresgid.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setresgid: display.o setresgid.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setuid.o: setuid.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setuid: display.o setuid.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setreuid.o: setreuid.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setreuid: display.o setreuid.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setresuid.o: setresuid.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setresuid: display.o setresuid.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

chown.o: chown.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

chown: display.o chown.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

lchown.o: lchown.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

lchown: display.o lchown.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

fchown.o: fchown.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

fchown: display.o fchown.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

fchownat.o: fchownat.c
	${CC} ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

fchownat: display.o fchownat.o
	${CC} ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

#ifneq (,$(filter $(arch_triplet), x86_64-linux-gnu aarch64-linux-gnu))
ifneq (,$(filter $(arch_triplet), x86_64-linux-gnu))
display32.o: display32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop32.o: drop32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop32: display32.o drop32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

drop-exec32.o: drop-exec32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop-exec32: display32.o drop-exec32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

drop-syscall32.o: drop-syscall32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

drop-syscall32: display32.o drop-syscall32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setgid32.o: setgid32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setgid32: display32.o setgid32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setregid32.o: setregid32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setregid32: display32.o setregid32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setresgid32.o: setresgid32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setresgid32: display32.o setresgid32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setuid32.o: setuid32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setuid32: display32.o setuid32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setreuid32.o: setreuid32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setreuid32: display32.o setreuid32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

setresuid32.o: setresuid32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

setresuid32: display32.o setresuid32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

chown32.o: chown32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

chown32: display32.o chown32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

lchown32.o: lchown32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

lchown32: display32.o lchown32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

fchown32.o: fchown32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

fchown32: display32.o fchown32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}

fchownat32.o: fchownat32.c
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $< -c ${LDLIBS}

fchownat32: display32.o fchownat32.o
	${CC} -m32 ${CFLAGS} ${LDFLAGS} $^ -o $@ ${LDLIBS}
endif


# Only depend on buildSecond on architectures where we are building it
# with -m32
#ifneq (,$(filter $(arch_triplet), x86_64-linux-gnu aarch64-linux-gnu))
ifneq (,$(filter $(arch_triplet), x86_64-linux-gnu))
install: $(buildNative) $(buildSecond)
else
install: $(buildNative)
endif
	mkdir -p ${INSTALL_DIR}
	cp -f drop ${INSTALL_DIR}/drop
	cp -f drop-exec ${INSTALL_DIR}/drop-exec
	cp -f drop-syscall ${INSTALL_DIR}/drop-syscall
	cp -f setgid ${INSTALL_DIR}/setgid
	cp -f setregid ${INSTALL_DIR}/setregid
	cp -f setresgid ${INSTALL_DIR}/setresgid
	cp -f setuid ${INSTALL_DIR}/setuid
	cp -f setreuid ${INSTALL_DIR}/setreuid
	cp -f setresuid ${INSTALL_DIR}/setresuid
	cp -f chown ${INSTALL_DIR}/chown
	cp -f lchown ${INSTALL_DIR}/lchown
	cp -f fchown ${INSTALL_DIR}/fchown
	cp -f fchownat ${INSTALL_DIR}/fchownat
#ifneq (,$(filter $(arch_triplet), x86_64-linux-gnu aarch64-linux-gnu))
ifneq (,$(filter $(arch_triplet), x86_64-linux-gnu))
	cp -f drop32 ${INSTALL_DIR}/drop32
	cp -f drop-exec32 ${INSTALL_DIR}/drop-exec32
	cp -f drop-syscall32 ${INSTALL_DIR}/drop-syscall32
	cp -f setgid32 ${INSTALL_DIR}/setgid32
	cp -f setregid32 ${INSTALL_DIR}/setregid32
	cp -f setresgid32 ${INSTALL_DIR}/setresgid32
	cp -f setuid32 ${INSTALL_DIR}/setuid32
	cp -f setreuid32 ${INSTALL_DIR}/setreuid32
	cp -f setresuid32 ${INSTALL_DIR}/setresuid32
	cp -f chown32 ${INSTALL_DIR}/chown32
	cp -f lchown32 ${INSTALL_DIR}/lchown32
	cp -f fchown32 ${INSTALL_DIR}/fchown32
	cp -f fchownat32 ${INSTALL_DIR}/fchownat32
else
	# *32 binaries are same on 32 bit systems
	cp -f drop ${INSTALL_DIR}/drop32
	cp -f drop-exec ${INSTALL_DIR}/drop-exec32
	cp -f drop-syscall ${INSTALL_DIR}/drop-syscall32
	cp -f setgid ${INSTALL_DIR}/setgid32
	cp -f setregid ${INSTALL_DIR}/setregid32
	cp -f setresgid ${INSTALL_DIR}/setresgid32
	cp -f setuid ${INSTALL_DIR}/setuid32
	cp -f setreuid ${INSTALL_DIR}/setreuid32
	cp -f setresuid ${INSTALL_DIR}/setresuid32
	cp -f chown ${INSTALL_DIR}/chown32
	cp -f lchown ${INSTALL_DIR}/lchown32
	cp -f fchown ${INSTALL_DIR}/fchown32
	cp -f fchownat ${INSTALL_DIR}/fchownat32
endif


clean:
	rm -f ./*.o
	rm -f ./drop ./drop32 ./drop-exec ./drop-exec32 ./drop-syscall ./drop-syscall32
	rm -f ./setgid ./setgid32 ./setregid ./setregid32 ./setresgid ./setresgid32
	rm -f ./setuid ./setuid32 ./setreuid ./setreuid32 ./setresuid ./setresuid32
	rm -f ./chown ./chown32 lchown lchown32 fchown fchown32 fchownat fchownat32

## snapd 2.72+ubuntu26.04.1

=== tests/lib/snaps/store/test-snapd-daemon-user/Makefile ===
all:
	cd ./src && make all

install:
	cd ./src && make install

clean:
	cd ./src && make clean

=== core-initrd/latest/debian/changelog ===
ubuntu-core-initramfs (72+2.71+g129.cddf2e3+25.10) questing; urgency=medium

  * Update to snapd version 2.71+g129.cddf2e3

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 28 Aug 2025 15:57:24 -0400

ubuntu-core-initramfs (72+2.70+g138.873912a+25.10) questing; urgency=medium

  * Update to snapd version 2.70+g138.873912a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 03 Jul 2025 21:50:50 -0400

ubuntu-core-initramfs (72+2.70+g50.d4bfa73+25.10) questing; urgency=medium

  * Update to snapd version 2.70+g50.d4bfa73

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 12 Jun 2025 10:17:45 -0400

ubuntu-core-initramfs (72+2.69+g139.0b18e2d+25.10) questing; urgency=medium

  * First questing release

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 22 May 2025 09:33:19 -0400

=== core-initrd/24.04/debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DH_VERBOSE=1
export DH_OPTIONS

BUILDFLAGS:=
# disable DWARF generation in go linker
BUILDFLAGS+=-ldflags=-w
# Disable -buildmode=pie mode on all our 32bit platforms
# (i386 and armhf). For i386 because of LP: #1711052 and for
# armhf because of LP: #1822738
ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_BITS),64)
BUILDFLAGS+=-buildmode=pie
endif

# check if we need to include the testkeys in the binary
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
# if enabled also enable bootloader assets testing and fault injection
_SNAP_TAGS:=nomanagers,withtestkeys,faultinject
else
_SNAP_TAGS:=nomanagers
endif

ifneq (,$(filter arm64 armhf,$(DEB_HOST_ARCH)))
_SNAP_TAGS:=$(_SNAP_TAGS),optee
endif

ifeq (${FIPSBUILD},1)
_SNAP_TAGS:=$(_SNAP_TAGS),goexperiment.opensslcrypto,snapdfips
endif

SNAP_TAGS=-tags "$(_SNAP_TAGS)"

######## targets start here

%:
	dh $@

override_dh_auto_build:
# very ugly test for FIPS variant of a toolchain
# see https://warthogs.atlassian.net/browse/FR-8860
ifeq (${FIPSBUILD},1)
	if ! test -f /usr/lib/go-1.21/src/crypto/internal/backend/openssl_linux.go; then \
		echo "Go 1.21 FIPS toolchain not found"; \
		exit 1; \
	fi
endif
# dh-golang sets GO111MODULE=off if present, fix that
	GOCACHE=/tmp/cache GO111MODULE=on go build -mod=vendor $(BUILDFLAGS) $(SNAP_TAGS) ./cmd/snap-bootstrap

override_dh_auto_install:
	rm -rf debian/tmp
	mkdir debian/tmp
	cp -ar factory/* debian/tmp

# splash functionality
	mkdir -p debian/tmp/usr/share/plymouth/themes/
	cp -a plymouth-theme-ubuntu-core/ubuntu-core \
		debian/tmp/usr/share/plymouth/themes/
	mkdir -p debian/tmp/usr/share/fonts/
	cp /usr/share/fonts/truetype/ubuntu/Ubuntu-R.ttf \
		debian/tmp/usr/share/fonts/Plymouth.ttf

	touch debian/tmp/etc/machine-id

override_dh_clean:
	dh_clean
	rm -f snap-bootstrap

# to avoid dh-golang breaking the build
override_dh_auto_test:

# disable dh_dwz (breaks build for go 1.22)
override_dh_dwz:

override_dh_python3:
	dh_python3 --no-ext-rename

override_dh_fixperms:
	dh_fixperms -Xusr/lib/ubuntu-core-initramfs/main

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/ubuntu-core-initramfs/main

override_dh_shlibdeps:
	dh_shlibdeps -Xusr/lib/ubuntu-core-initramfs/main
